## yade 2021.01a

=== CMakeLists.txt ===
# The YADE has the following parameters to configure:
#  CMAKE_INSTALL_PREFIX: path, where Yade will be installed (/usr/local by default)
#  LIBRARY_OUTPUT_PATH: path to install libraries (lib by default)
#  DEBUG: compile in debug-mode (OFF by default)
#  ENABLE_LOGGER: use boost::log library for logging (ON by default)
#  MAX_LOG_LEVEL: set maximum level for LOG_* macros compiled with ENABLE_LOGGER. For production build use MAX_LOG_LEVEL<=5, to avoid filter integer comparison on each call to LOG_TRACE(…)
#  ENABLE_USEFUL_ERRORS: enable useful compiler errors which help a lot in error-free development.
#  CMAKE_VERBOSE_MAKEFILE: output additional information during compiling (OFF by default)
#  SUFFIX: suffix, added after binary-names (version number by default)
#  NOSUFFIX: do not add a suffix after binary-name (OFF by default)
#  YADE_VERSION: explicitely set version number (is defined from git-directory by default)
#  ENABLE_GUI: enable GUI option (ON by default)
#  ENABLE_CGAL: enable CGAL option (ON by default)
#  ENABLE_VTK: enable VTK-export option (ON by default)
#  ENABLE_OPENMP: enable OpenMP-parallelizing option (ON by default)
#  ENABLE_MPI : Enable MPI communications in Yade. Used for Yade-OpenFOAM coupling.
#  ENABLE_GTS: enable GTS-option (ON by default)
#  ENABLE_GL2PS: enable GL2PS-option (ON by default)
#  ENABLE_LINSOLV: enable LINSOLV-option (ON by default)
#  ENABLE_PFVFLOW: enable PFVFLOW-option, FlowEngine (ON by default)
#  ENABLE_TWOPHASEFLOW: enable TWOPHASEFLOW-option, TwoPhaseFlowEngine (ON by default)
#  ENABLE_LBMFLOW: enable LBMFLOW-option, LBM_ENGINE (ON by default)
#  ENABLE_SPH: enable SPH-option, Smoothed Particle Hydrodynamics (OFF by default)
#  ENABLE_LIQMIGRATION: enable LIQMIGRATION-option, see [Mani2013] for details (OFF by default)
#  ENABLE_MASK_ARBITRARY: enable MASK_ARBITRARY option (OFF by default)
#  ENABLE_PROFILING: enable profiling, e.g. shows some more metrics, which can define bottlenecks of the code (OFF by default)
#  ENABLE_POTENTIAL_BLOCKS: enable potential blocks option (ON by default)
#  ENABLE_POTENTIAL_PARTICLES: enable potential particles option (ON by default)
#  ENABLE_DEFORM: enable constant volume deformation engine (OFF by default)
#  ENABLE_FEMLIKE: enable meshed solids (FEM-like)
#  ENABLE_OAR: generate a script for oar-based task scheduler (OFF by default)
#  ENABLE_ASAN: AddressSanitizer build, please see documentation (OFF by default)
#  ENABLE_MPFR: use https://www.mpfr.org/ library, can be used for higher precision calculations or for CGAL exact predicates (OFF by default)
#  ENABLE_PARTIALSAT: enable the partially saturated clay engine, under construction (OFF by default)
#  REAL_PRECISION_BITS , REAL_DECIMAL_PLACES: specify either of them to use a custom calculation precision. By default double (64 bits, 15 decimal places) precision is used.
#  runtimePREFIX: used for packaging, when install directory is not the same is runtime directory (/usr/local by default)
#  CHUNKSIZE: set >1, if you want several sources to be compiled at once. Increases compilation speed and RAM-consumption during it (1 by default)
#  VECTORIZE: enables vectorization and alignment in Eigen3 library, experimental (OFF by default)
#  USE_QT5: use QT5 for GUI (ON by default)
#  CHOLMOD_GPU link Yade to custom SuiteSparse installation and activate GPU accelerated PFV (OFF by default)
#  SUITESPARSEPATH: define this variable with the path to a custom suitesparse install
#  PYTHON_VERSION: force python version to the given one, set -1 to automatically use the last version on the system. (-1 by default)

project(Yade C CXX)
cmake_minimum_required(VERSION 3.5.0)
IF(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 7.0.0)
  set (CMAKE_CXX_STANDARD 14)
ELSE()
  set (CMAKE_CXX_STANDARD 17)
ENDIF()
set (CMAKE_CXX_STANDARD_REQUIRED ON)

# https://misc.flogisoft.com/bash/tip_colors_and_formatting
# https://stackoverflow.com/questions/18968979/how-to-get-colorized-output-with-cmake , use ${Esc} for printing colors
string(ASCII 27 Esc)
# To have a cmake option with multiple values I used https://cmake.org/pipermail/cmake/2016-October/064342.html
# set maximum level for LOG_* macros compiled with ENABLE_LOGGER. For production build use MAX_LOG_LEVEL below 5, to avoid filter integer comparison on each call to LOG_TRACE(…)
set(MAX_LOG_LEVEL "5" CACHE STRING "default MAX_LOG_LEVEL")
set_property(CACHE MAX_LOG_LEVEL PROPERTY STRINGS "0" "1" "2" "3" "4" "5" "6")  # define list of values GUI will offer for the variable


#===========================================================
SET(DEFAULT ON CACHE INTERNAL "Default value for enabled by default options")
SET(LINKLIBS "")
SET(CONFIGURED_FEATS "")
SET(DISABLED_FEATS "")

OPTION(ENABLE_LOGGER "use boost::log library for logging (ON by default)" ON)
OPTION(ENABLE_USEFUL_ERRORS "enable useful compiler errors which help a lot in error-free development." ON)
OPTION(ENABLE_VTK "Enable VTK" ${DEFAULT})
OPTION(ENABLE_OPENMP "Enable OpenMP" ${DEFAULT})
OPTION(ENABLE_MPI "Enable MPI environement and communications, required for coupling Yade with OpenFOAM  " ON)
OPTION(ENABLE_GTS "Enable GTS" ${DEFAULT})
OPTION(ENABLE_GUI "Enable GUI" ${DEFAULT})
OPTION(ENABLE_CGAL "Enable CGAL" ${DEFAULT})
OPTION(ENABLE_GL2PS "Enable GL2PS" ${DEFAULT})
OPTION(ENABLE_LINSOLV "Enable direct solver for the flow engines (experimental)" ${DEFAULT})
OPTION(ENABLE_PFVFLOW "Enable one-phase flow engines" ${DEFAULT})
OPTION(ENABLE_TWOPHASEFLOW "Enable two-phase flow engines" ${DEFAULT})
OPTION(ENABLE_SPH "Enable SPH" OFF)
OPTION(ENABLE_LBMFLOW "Enable LBM engine (very experimental)" ON)
OPTION(ENABLE_LIQMIGRATION "Enable liquid control (very experimental), see [Mani2013] for details" OFF)
OPTION(ENABLE_MASK_ARBITRARY "Enable arbitrary precision of bitmask variables (only Body::groupMask yet implemented) (experimental). Use -DMASK_ARBITRARY_SIZE=int to set number of used bits (256 by default)" OFF)
OPTION(ENABLE_PROFILING "Enable profiling, e.g. shows some more metrics, which can define bottlenecks of the code (OFF by default)" OFF)
OPTION(ENABLE_POTENTIAL_PARTICLES "Enable potential particles" ON)
OPTION(ENABLE_OAR "Generate script for oar-based task scheduler" OFF)
OPTION(ENABLE_MPFR "Use mpfr library (higher precision calculations or CGAL exact predicates)" OFF)
OPTION(USE_QT5 "USE Qt5 for GUI" ON)
OPTION(ENABLE_POTENTIAL_BLOCKS "Enable PotentialBlocks" ON)
OPTION(ENABLE_DEFORM "Enable Deformation Engine" OFF)
OPTION(ENABLE_FEMLIKE "Enable deformable solids" ON)
OPTION(CHOLMOD_GPU "Enable GPU acceleration flow engine direct solver" OFF)
OPTION(ENABLE_THERMAL "Enable thermal engine (experimental)" ON)
OPTION(ENABLE_ASAN "Enable AddressSanitizer build, please see documentation" OFF)
OPTION(ENABLE_PARTIALSAT "Enable the partially saturated clay engine" ${DEFAULT})
#Set -DPYTHON_VERSION numeric option below:
set(PYTHON_VERSION -1 CACHE STRING "Force python version to the given one. Defaults to -DPYTHON_VERSION=-1 which automatically uses the newest available python version on the system.")
#===========================================================



set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cMake")

INCLUDE(GetVersion)
INCLUDE(GNUInstallDirs)

INCLUDE_DIRECTORIES (${CMAKE_SOURCE_DIR})

#===========================================================
# HACK!!! If the version of gcc is 4.8 or greater, we add -ftrack-macro-expansion=0
# and -save-temps into compiler to reduce the memory consumption during compilation.
# See http://bugs.debian.org/726009 for more information
# Can be removed later, if gcc fixes its regression
# Taken from http://stackoverflow.com/questions/4058565/check-gcc-minor-in-cmake

# this line was trying to get the g++ version. But it does not work with ccache.
# But we already have CMAKE_CXX_COMPILER_VERSION, so we don't need this line!
#EXECUTE_PROCESS(COMMAND ${CMAKE_C_COMPILER} -dumpversion OUTPUT_VARIABLE GCC_VERSION)

IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")  # Check whether we compile with GCC
  IF (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 4.8 OR CMAKE_CXX_COMPILER_VERSION VERSION_EQUAL 4.8)
    MESSAGE(STATUS "GCC Version >= 4.8. Adding -ftrack-macro-expansion=0")
    ADD_DEFINITIONS("-ftrack-macro-expansion=0")
  ELSE()
    MESSAGE(STATUS "GCC Version < 4.8. will not use -ftrack-macro-expansion=0")
  ENDIF()
ENDIF()

# -save-temps is not supported with ccache
IF ((CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 4.8 OR CMAKE_CXX_COMPILER_VERSION VERSION_EQUAL 4.8) AND ( NOT "${CMAKE_CXX_COMPILER_LAUNCHER}" MATCHES ".*ccache" AND NOT "${CMAKE_CXX_COMPILER}" MATCHES ".*ccache.*" AND NOT DISABLE_SAVE_TEMPS))
  MESSAGE(STATUS "GCC Version >= 4.8. Adding -save-temps")
  ADD_DEFINITIONS("-save-temps")
ELSE()
  IF ( "${CMAKE_CXX_COMPILER_LAUNCHER}" MATCHES ".*ccache" OR "${CMAKE_CXX_COMPILER}" MATCHES ".*ccache.*" )
    MESSAGE(STATUS "ccache detected, will not use -save-temps")
# on ubuntu 18.04 and 18.10 when ccache is used we need to fix some bug, see https://gitlab.kitware.com/cmake/cmake/issues/17275
# but we can't do this on ubuntu 16.04 with cmake version 3.5.1, because that produces error: "list does not recognize sub-command FILTER".
# So we must be above version 3.6, because https://cmake.org/cmake/help/v3.6/release/3.6.html?highlight=filter
# Later maybe on some higher cmake version this will become unnecessary.
    IF(CMAKE_VERSION VERSION_GREATER 3.6 OR CMAKE_VERSION VERSION_EQUAL 3.6)
        string (STRIP "${CMAKE_CXX_COMPILER_ARG1}" __CXX_COMPILER_ARG1)
        set(CMAKE_CXX_COMPILER_PREDEFINES_COMMAND "${CMAKE_CXX_COMPILER}" "${__CXX_COMPILER_ARG1}" "-dM" "-E" "-c" "${CMAKE_ROOT}/Modules/CMakeCXXCompilerABI.cpp")
        list(FILTER CMAKE_CXX_COMPILER_PREDEFINES_COMMAND EXCLUDE REGEX "^$")
        unset(__CXX_COMPILER_ARG1)
    ENDIF()
  ELSE()
    MESSAGE(STATUS "GCC Version < 4.8 or DISABLE_SAVE_TEMPS. will not use -save-temps")
  ENDIF()
ENDIF()

#===========================================================

FIND_PACKAGE(Eigen3 REQUIRED)

#===========================================================
# AddressSanitizer build
IF(ENABLE_ASAN)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O1 -g -fsanitize=address -fno-omit-frame-pointer")
  SET(CMAKE_BUILD_TYPE Debug)
  SET(CMAKE_VERBOSE_MAKEFILE 1)
ENDIF(ENABLE_ASAN)
#===========================================================

IF(DEBUG)
  SET(CMAKE_VERBOSE_MAKEFILE 1)
  SET(CMAKE_BUILD_TYPE Debug)
  ADD_DEFINITIONS("-DYADE_DEBUG")
ELSE (DEBUG)
  IF (NOT(CMAKE_BUILD_TYPE))
    # If no build_type set, we use Release profile
    SET(CMAKE_BUILD_TYPE Release)
  ENDIF (NOT(CMAKE_BUILD_TYPE))
ENDIF (DEBUG)

IF(ENABLE_LOGGER)
  MESSAGE(STATUS "${Esc}[36mLog filtering: enabled${Esc}[0m")
  SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} BoostLog")
  ADD_DEFINITIONS("-DYADE_BOOST_LOG")
  ADD_DEFINITIONS("-DBOOST_LOG_DYN_LINK")
  IF (DEBUG)
    MESSAGE(STATUS "Enabling boost::log library and DEBUG=ON. Files will be very large with full debug info inside.")
    IF(${MAX_LOG_LEVEL} LESS 6)
      MESSAGE(STATUS "${Esc}[33mWarning: using DEBUG=ON with MAX_LOG_LEVEL=${MAX_LOG_LEVEL} (less than 6, the maximum log level) rarely makes sense, use cmake option MAX_LOG_LEVEL=6 to fix this.${Esc}[0m")
    ENDIF()
  ELSE (DEBUG)
    MESSAGE(STATUS "Enabling boost::log library and DEBUG=OFF. Logging will work nicely, backtraces will not have debug info, files will be small.")
  ENDIF (DEBUG)
ELSE(ENABLE_LOGGER)
  MESSAGE(STATUS "${Esc}[36mLog filtering: disabled${Esc}[0m")
  IF (DEBUG)
    MESSAGE(STATUS "Disabling boost::log library (only rudimentary LOG_* macros will work) and DEBUG=ON. Files will be very large with full debug info inside.")
  ELSE (DEBUG)
    MESSAGE(STATUS "Disabling boost::log library (only rudimentary LOG_* macros will work, and only up to LOG_WARN) and DEBUG=OFF. Backtraces will not have debug info, files will be small.")
  ENDIF (DEBUG)
ENDIF(ENABLE_LOGGER)

ADD_DEFINITIONS("-DMAX_LOG_LEVEL=${MAX_LOG_LEVEL}")

=== gui/CMakeLists.txt ===
IF(${ENABLE_GUI})
  INCLUDE_DIRECTORIES(${QGLVIEWER_INCLUDE_DIR})
  IF(USE_QT5)
    SET(CMAKE_AUTOMOC ON)
    SET(_GLViewer_SOURCE_FILES qt5/GLViewer.cpp;qt5/_GLViewer.cpp;qt5/OpenGLManager.cpp;qt5/GLViewerDisplay.cpp;qt5/GLViewerMouse.cpp)
    ADD_LIBRARY(_GLViewer SHARED ${_GLViewer_SOURCE_FILES})
    SET_TARGET_PROPERTIES(_GLViewer PROPERTIES PREFIX "")
    TARGET_LINK_LIBRARIES(_GLViewer Qt5::Widgets Qt5::Xml Qt5::OpenGL
                                    ${GLUT_LIBRARY} ${OPENGL_LIBRARY}
                                    ${QGLVIEWER_LIBRARIES}
                                    ${Boost_LIBRARIES} ${PYTHON_LIBRARIES})
    IF(GL2PS_FOUND AND ENABLE_GL2PS)
      TARGET_LINK_LIBRARIES(_GLViewer ${GL2PS_LIBRARIES})
    ENDIF(GL2PS_FOUND AND ENABLE_GL2PS)
    INSTALL(TARGETS _GLViewer DESTINATION ${YADE_PY_PATH}/yade/qt)
    
    FILE(GLOB filesPYQT "${CMAKE_CURRENT_SOURCE_DIR}/qt5/*.py")
    INSTALL(FILES ${filesPYQT} DESTINATION ${YADE_PY_PATH}/yade/qt)
    
    EXECUTE_PROCESS(
          COMMAND "pyrcc5" "-o" "${CMAKE_BINARY_DIR}/img_rc.py" "img.qrc"
          WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/qt5
          RESULT_VARIABLE rv
          )
    
    EXECUTE_PROCESS(
          COMMAND "pyuic5" "--from-imports" "-o" "${CMAKE_BINARY_DIR}/ui_controller.py" "controller.ui"
          WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/qt5
          RESULT_VARIABLE rv
          )
    INSTALL(FILES ${CMAKE_BINARY_DIR}/img_rc.py ${CMAKE_BINARY_DIR}/ui_controller.py  DESTINATION ${YADE_PY_PATH}/yade/qt)
    TARGET_LINK_LIBRARIES(_GLViewer Qt5::Widgets Qt5::Xml Qt5::OpenGL
                                    ${GLUT_LIBRARY} ${OPENGL_LIBRARY}
                                    ${QGLVIEWER_LIBRARIES}
                                    ${Boost_LIBRARIES} ${PYTHON_LIBRARIES})
    IF(GL2PS_FOUND AND ENABLE_GL2PS)
      TARGET_LINK_LIBRARIES(_GLViewer ${GL2PS_LIBRARIES})
    ENDIF(GL2PS_FOUND AND ENABLE_GL2PS)
    INSTALL(TARGETS _GLViewer DESTINATION ${YADE_PY_PATH}/yade/qt)
    
    FILE(GLOB filesPYQT "${CMAKE_CURRENT_SOURCE_DIR}/qt5/*.py")
    INSTALL(FILES ${filesPYQT} DESTINATION ${YADE_PY_PATH}/yade/qt)
    
    EXECUTE_PROCESS(
          COMMAND "pyrcc5" "-o" "${CMAKE_BINARY_DIR}/img_rc.py" "img.qrc"
          WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/qt5
          RESULT_VARIABLE rv
          )
    
    EXECUTE_PROCESS(
          COMMAND "pyuic5"  "--from-imports" "-o" "${CMAKE_BINARY_DIR}/ui_controller.py" "controller.ui"
          WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/qt5
          RESULT_VARIABLE rv
          )
    INSTALL(FILES ${CMAKE_BINARY_DIR}/img_rc.py ${CMAKE_BINARY_DIR}/ui_controller.py  DESTINATION ${YADE_PY_PATH}/yade/qt)
  ELSE(USE_QT5)
    MESSAGE(FATAL_ERROR "QT4 is no longer supported")
  ENDIF(USE_QT5)
ENDIF(${ENABLE_GUI})

=== py/CMakeLists.txt ===
#==================pygts=========================================
IF(ENABLE_GTS)
  find_python_module(gts)
  IF (PY_gts)
    MESSAGE(STATUS "Use system gts version")
  ELSE (PY_gts)
    MESSAGE(STATUS "Use embedded version of gts. Please, consider installing the corresponding package")
    FILE(GLOB SRC_PYGTS "${CMAKE_CURRENT_SOURCE_DIR}/3rd-party/pygts-0.3.1/*.cpp")
    ADD_LIBRARY(_gts SHARED ${SRC_PYGTS})
    SET_TARGET_PROPERTIES(_gts PROPERTIES PREFIX "")
    TARGET_LINK_LIBRARIES(_gts gts)
    INSTALL(FILES 3rd-party/pygts-0.3.1/__init__.py DESTINATION ${YADE_LIB_PATH}/py/gts)
    INSTALL(FILES 3rd-party/pygts-0.3.1/pygts.py DESTINATION ${YADE_LIB_PATH}/py/gts)
    INSTALL(TARGETS _gts DESTINATION ${YADE_LIB_PATH}/py/gts)
  ENDIF (PY_gts)
ENDIF(ENABLE_GTS)
#==================pygts=========================================

#==================pyModules=========================================

FILE(GLOB filesPY "${CMAKE_CURRENT_SOURCE_DIR}/*.py")
SET(filesPY "${filesPY};${CMAKE_CURRENT_SOURCE_DIR}/pack/pack.py")
INSTALL(FILES ${filesPY} DESTINATION ${YADE_PY_PATH}/yade)
INSTALL(FILES 3rd-party/mtTkinter-0.4/mtTkinter.py DESTINATION ${YADE_LIB_PATH}/py)
FILE(GLOB filesPYTests "${CMAKE_CURRENT_SOURCE_DIR}/tests/*.py")
INSTALL(FILES ${filesPYTests} DESTINATION ${YADE_PY_PATH}/yade/tests)
FILE(GLOB filesPYPerf "${CMAKE_CURRENT_SOURCE_DIR}/../examples/test/performance/*")
INSTALL(FILES ${filesPYPerf} DESTINATION ${YADE_PY_PATH}/yade/tests/checks/performance)
FILE(GLOB filesFEMxDEM "${CMAKE_CURRENT_SOURCE_DIR}/FEMxDEM/*.py")
INSTALL(FILES ${filesFEMxDEM} DESTINATION ${YADE_PY_PATH}/yade/FEMxDEM)

ADD_LIBRARY(_libVersions SHARED "${CMAKE_CURRENT_SOURCE_DIR}/_libVersions.cpp")
SET_TARGET_PROPERTIES(_libVersions PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(_libVersions yade)
INSTALL(TARGETS _libVersions DESTINATION "${YADE_PY_PATH}/yade/")

# hint: follow changes in d067b0696a8 to add new modules.
ADD_LIBRARY(_log SHARED "${CMAKE_CURRENT_SOURCE_DIR}/_log.cpp")
SET_TARGET_PROPERTIES(_log PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(_log yade)
INSTALL(TARGETS _log DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(_math SHARED "${CMAKE_CURRENT_SOURCE_DIR}/high-precision/_math.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/high-precision/_ExposeStorageOrdering.cpp")
SET_TARGET_PROPERTIES(_math PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(_math yade)
INSTALL(TARGETS _math DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(_minieigenHP SHARED "${CMAKE_CURRENT_SOURCE_DIR}/high-precision/_minieigenHP.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/high-precision/_ExposeBoxes.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/high-precision/_ExposeComplex1.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/high-precision/_ExposeComplex2.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/high-precision/_ExposeConverters.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/high-precision/_ExposeMatrices1.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/high-precision/_ExposeMatrices2.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/high-precision/_ExposeQuaternion.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/high-precision/_ExposeStorageOrdering.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/high-precision/_ExposeVectors1.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/high-precision/_ExposeVectors2.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/high-precision/_RealHPDiagnostics.cpp")
SET_TARGET_PROPERTIES(_minieigenHP PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(_minieigenHP yade)
INSTALL(TARGETS _minieigenHP DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(WeightedAverage2d SHARED "${CMAKE_CURRENT_SOURCE_DIR}/WeightedAverage2d.cpp")
SET_TARGET_PROPERTIES(WeightedAverage2d PROPERTIES PREFIX "")
INSTALL(TARGETS WeightedAverage2d DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(_utils SHARED "${CMAKE_CURRENT_SOURCE_DIR}/_utils.cpp")
SET_TARGET_PROPERTIES(_utils PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(_utils yade)
INSTALL(TARGETS _utils DESTINATION "${YADE_PY_PATH}/yade/")


ADD_LIBRARY(_polyhedra_utils SHARED "${CMAKE_CURRENT_SOURCE_DIR}/_polyhedra_utils.cpp")
SET_TARGET_PROPERTIES(_polyhedra_utils PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(_polyhedra_utils)
INSTALL(TARGETS _polyhedra_utils DESTINATION "${YADE_PY_PATH}/yade/")


ADD_LIBRARY(_packPredicates SHARED "${CMAKE_CURRENT_SOURCE_DIR}/pack/_packPredicates.cpp")
SET_TARGET_PROPERTIES(_packPredicates PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(_packPredicates yade)
IF(ENABLE_GTS AND NOT(PY_gts))
  TARGET_LINK_LIBRARIES(_packPredicates _gts)
ENDIF(ENABLE_GTS AND NOT(PY_gts))


INSTALL(TARGETS _packPredicates DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(_packSpheres SHARED "${CMAKE_CURRENT_SOURCE_DIR}/pack/_packSpheres.cpp")
SET_TARGET_PROPERTIES(_packSpheres PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(_packSpheres yade)
INSTALL(TARGETS _packSpheres DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(_packObb SHARED "${CMAKE_CURRENT_SOURCE_DIR}/pack/_packObb.cpp")
SET_TARGET_PROPERTIES(_packObb PROPERTIES PREFIX "")
INSTALL(TARGETS _packObb DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(wrapper SHARED "${CMAKE_CURRENT_SOURCE_DIR}/wrapper/yadeWrapper.cpp")
SET_TARGET_PROPERTIES(wrapper PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(wrapper yade)
INSTALL(TARGETS wrapper DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(_customConverters SHARED "${CMAKE_CURRENT_SOURCE_DIR}/wrapper/customConverters.cpp")
SET_TARGET_PROPERTIES(_customConverters PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(_customConverters yade)
INSTALL(TARGETS _customConverters DESTINATION "${YADE_PY_PATH}/yade/")

=== debian/changelog ===
yade (2021.01a-3) unstable; urgency=medium

  * [3187a87] Add python3-mpi4py in dependencies

 -- Anton Gladky <gladk@debian.org>  Sun, 31 Jan 2021 09:41:34 +0100

yade (2021.01a-2) unstable; urgency=medium

  * [14189ec] Disable MPI scripts

 -- Anton Gladky <gladk@debian.org>  Sat, 30 Jan 2021 09:52:42 +0100

yade (2021.01a-2~exp1) experimental; urgency=medium

  * [2019289] Try to enable MPI

 -- Anton Gladky <gladk@debian.org>  Thu, 28 Jan 2021 19:59:56 +0100

yade (2021.01a-1) unstable; urgency=medium

  * [37b3ec0] New upstream version 2021.01a
  * [1bdbffa] Remove unused patch
  * [046c6a8] Ignore quilt dir
  * [3c4e204] Update description of the patch

 -- Anton Gladky <gladk@debian.org>  Sun, 17 Jan 2021 19:26:03 +0100

yade (2021.01~git~3a576ca-1) experimental; urgency=medium

  * [80a92cc] New upstream version 2021.01~git~3a576ca
  * [490127a] Remove applied by upstream patches
  * [535af2e] Disable DEM-PFV-check.py test

 -- Anton Gladky <gladk@debian.org>  Sun, 17 Jan 2021 10:06:46 +0100

yade (2021.01~git~2~e7655b1-2) experimental; urgency=medium

  * [300dbde] Disable JCFpm-test
  * [0ec3178] Workaround one test on 32-bit platform

 -- Anton Gladky <gladk@debian.org>  Sat, 16 Jan 2021 09:48:21 +0100

yade (2021.01~git~2~e7655b1-1) experimental; urgency=medium

  * [acc7d10] New upstream version 2021.01~git~2~e7655b1
  * [d1fb261] Refresh patches

 -- Anton Gladky <gladk@debian.org>  Fri, 15 Jan 2021 19:03:59 +0100

yade (2021.01~git~1~7243a772-1~exp3) experimental; urgency=medium

  * [0a889be] Fix compilation

 -- Anton Gladky <gladk@debian.org>  Wed, 13 Jan 2021 19:48:00 +0100

yade (2021.01~git~1~7243a772-1~exp2) experimental; urgency=medium

  * [fc63699] Add VTK9 patch
  * [233f590] Switch to VTK9

 -- Anton Gladky <gladk@debian.org>  Tue, 12 Jan 2021 22:30:12 +0100

yade (2021.01~git~1~7243a772-1~exp1) experimental; urgency=medium

  * [2fb17be] New upstream version 2021.01~git~1~7243a772

 -- Anton Gladky <gladk@debian.org>  Mon, 11 Jan 2021 23:07:37 +0100

yade (2021.01~git~0~088ea96-1~exp3) experimental; urgency=medium

  * [7c5ae19] Disable MPI

 -- Anton Gladky <gladk@debian.org>  Mon, 11 Jan 2021 17:31:15 +0100

yade (2021.01~git~0~088ea96-1~exp2) experimental; urgency=medium

  * [6992ebe] Fix compilation on arm and ppc
  * [48998dd] Disable checkMPISilo script

 -- Anton Gladky <gladk@debian.org>  Sun, 10 Jan 2021 18:49:02 +0100

yade (2021.01~git~0~088ea96-1~exp1) experimental; urgency=medium

  * [c0dd3eb] New upstream version 2021.01~git~0~088ea96
  * [98bc538] Clean patches
  * [d5b90b9] Update d/copyright
  * [a461c4c] Use --checkall for tests
  * [049e86b] Minor fix in d/control
  * [09ca779] Set Standards-Version to 4.5.1
  * [f1b9991] Ignore quilt dir

 -- Anton Gladky <gladk@debian.org>  Sat, 09 Jan 2021 20:49:48 +0100

yade (2020.01a-13) unstable; urgency=medium

  * [752a547] Use python3-dev instead of python3-all-dev.
              (Closes: #975897)
  * [d835e63], [c85d421] Support python 3.9.
              (Closes: #975878)
  * [320f3af] Ignore quilt dir
  * [002a263] Update renamed lintian tag names in lintian overrides.
  * [5e63e04] Update watch file format version to 4.
  * [0340d8b] Apply cme fix dpkg
  * [b5ada51] Update changelog.
  * [dc4c833] Fix python3.9 compilation
  * [cc66be1] Update changelog.
  * [5f73f40] Fix check-script (polyhedrasplit)

 -- Anton Gladky <gladk@debian.org>  Tue, 01 Dec 2020 23:11:51 +0100

yade (2020.01a-12) unstable; urgency=medium

  * [ecff333] Fix compilation against QT_5.15

 -- Anton Gladky <gladk@debian.org>  Wed, 04 Nov 2020 16:28:55 +0100

yade (2020.01a-11) unstable; urgency=medium

  * [4d92517] Disable some tests. (Closes: #972816)
  * [3cb65c0] Convert patches to gbp pq format
  * [7812d54] Drop deprecated dependency on gtk2-engines-pixbuf.xi
              (Closes: #947713)

 -- Anton Gladky <gladk@debian.org>  Mon, 02 Nov 2020 21:41:55 +0100

=== debian/control ===
Source: yade
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Anton Gladky <gladk@debian.org>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-exec,
               dh-python,
               freeglut3-dev,
               help2man,
               libboost-all-dev,
               libbz2-dev,
               libcgal-dev,
               libeigen3-dev,
               libgl1-mesa-dev,
               libgmp-dev,
               libgts-dev,
               libmetis-dev,
               libopenblas-dev,
               libqglviewer-dev-qt5,
               libsqlite3-dev,
               libsuitesparse-dev,
               libvtk9-dev,
               libxi-dev,
               libxmu-dev,
               pyqt5-dev-tools,
               python3-dev,
               python3-future,
               python3-ipython,
               python3-matplotlib,
               python3-minieigen,
               python3-mpi4py,
               python3-numpy,
               python3-pil,
               python3-pygraphviz,
               python3-pyqt5,
               python3-pyqt5.qtsvg,
               python3-tk,
               python3-xlib,
               zlib1g-dev
Build-Depends-Indep: dvipng,
                     graphviz,
                     libjs-jquery,
                     lmodern,
                     python3-bibtexparser,
                     python3-sphinx,
                     texlive-fonts-recommended,
                     texlive-plain-generic,
                     texlive-latex-extra,
                     texlive-latex-recommended,
                     texlive-pictures,
                     texlive-xetex,
                     tipa
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/science-team/yade
Vcs-Git: https://salsa.debian.org/science-team/yade.git
Homepage: https://yade-dem.org/doc/

Package: yade
Architecture: amd64 arm64 i386 ppc64el s390x
Multi-Arch: foreign
Depends: gnuplot,
         libyade (= ${binary:Version}),
         python3-yade (= ${binary:Version}),
         python3-ipython,
         python3-mpi4py,
         python3-pyqt5.qtwebkit,
         ${python3:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Platform for discrete element modeling
 Yet Another Dynamic Engine.
 .
 Extensible open-source framework for discrete numerical models,
 focused on Discrete Element Method.
 The computation parts are written in c++ using flexible object model,
 allowing independent implementation of new algorithms and interfaces.
 Python is used for rapid and concise scene construction,
 simulation control, postprocessing and debugging.
 .
 This package contains speed-optimized build of yade.

Package: libyade
Architecture: amd64 arm64 i386 ppc64el s390x
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Platform for discrete element modeling. Libraries
 Yet Another Dynamic Engine.
 .
 Extensible open-source framework for discrete numerical models,
 focused on Discrete Element Method.
 The computation parts are written in c++ using flexible object model,
 allowing independent implementation of new algorithms and interfaces.
 Python is used for rapid and concise scene construction,
 simulation control, postprocessing and debugging.
 .
 This package contains yade`s libraries.

Package: python3-yade
Architecture: amd64 arm64 i386 ppc64el s390x
Multi-Arch: foreign
Section: python
Depends: libyade (= ${binary:Version}),
         python3-future,
         python3-matplotlib,
         python3-minieigen,
         python3-pil,
         python3-pyqt5,
         python3-pyqt5.qtsvg,
         python3-tk,
         python3-xlib,
         python3-mpi4py,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Platform for discrete element modeling. Python bindings
 Yet Another Dynamic Engine.
 .
 Extensible open-source framework for discrete numerical models,
 focused on Discrete Element Method.
 The computation parts are written in c++ using flexible object model,
 allowing independent implementation of new algorithms and interfaces.
 Python is used for rapid and concise scene construction,
 simulation control, postprocessing and debugging.
 .
 This package contains python bindings for yade.

Package: yade-doc
Architecture: all
Section: doc
Depends: ${sphinxdoc:Depends},
         ${misc:Depends},
         libjs-mathjax
Recommends: yade
Description: Platform for discrete element modeling. Documentation
 Yet Another Dynamic Engine.
 .
 Extensible open-source framework for discrete numerical models,
 focused on Discrete Element Method.
 The computation parts are written in c++ using flexible object model,
 allowing independent implementation of new algorithms and interfaces.
 Python is used for rapid and concise scene construction,
 simulation control, postprocessing and debugging.
 .
 This package contains examples, test scripts and documentation.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

BUILDDIR = $(CURDIR)/debian/build
tmpInstall = $(CURDIR)/debian/tmp
tmpDirMatplotLib = $(CURDIR)/debian/matplotlib

# do not build i386 parallely
ifneq (,$(filter $(DEB_HOST_ARCH), i386 s390x all))
	parallelBuild=--no-parallel
endif

# We disable parallel builds on all platforms by now
# Ubuntu has problems with it and it causes sync-delays
parallelBuild=--no-parallel

%:
	dh $@ --builddirectory=$(BUILDDIR) --with python3 $(parallelBuild)

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed,-no-keep-memory

# no debug info to avoid running
# out of address space when linking
ifneq (,$(filter $(DEB_HOST_ARCH), mips mipsel i386))
	export DEB_CXXFLAGS_MAINT_APPEND += -g0
endif

# Check, whether Build-Depends-Indep are installed
BUILD_DOC=$(shell dpkg -s python3-sphinx | grep -q "^Status:.* installed$$" && echo yes)

export MPLCONFIGDIR := $(tmpDirMatplotLib)
export HOME := $(tmpDirMatplotLib)
export LD_LIBRARY_PATH :=  $(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade/py:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade/py:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade/py/gts:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade/py/yade:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade/py/yade/qt:$(LD_LIBRARY_PATH)
export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export YADE_PREFIX := $(tmpInstall)/usr

extra_flags += \
-DruntimePREFIX="/usr" \
-DCMAKE_INSTALL_PREFIX="/usr" \
-DNOSUFFIX=ON \
-DLIBRARY_OUTPUT_PATH=lib/$(DEB_HOST_MULTIARCH) \
-DENABLE_SPH=ON \
-DPYTHON_VERSION=3

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags)
	mkdir -p $(tmpDirMatplotLib)
	mkdir -p $(tmpInstall)
	#Output an information about available memory and CPU
	-cat /proc/meminfo
	-cat /proc/cpuinfo

override_dh_auto_install:
	dh_auto_install
	# generate manpages
	help2man $(tmpInstall)/usr/bin/yade > yade.1
	help2man $(tmpInstall)/usr/bin/yade-batch > yade-batch.1
	$(tmpInstall)/usr/bin/yade --test
	$(tmpInstall)/usr/bin/yade --checkall
	dh_numpy3
ifeq ($(BUILD_DOC), yes)
	#Generate docs
	cd $(CURDIR)/doc/sphinx && PYTHONPATH=. $(tmpInstall)/usr/bin/yade yadeSphinx.py html && PYTHONPATH=. $(tmpInstall)/usr/bin/yade yadeSphinx.py latex && cd _build/latex && xelatex Yade.tex && xelatex Yade.tex && xelatex Yade.tex
	cd $(CURDIR)/doc/sphinx/_build/html && find . -type f -print0 | xargs -0 sed -i 's/https:\/\/cdnjs\.cloudflare\.com\/ajax\/libs\/mathjax\/2\.7\.5\/latest.js/\/usr\/share\/javascript\/mathjax\/MathJax.js\//g'
	cd $(CURDIR)/doc/sphinx/_build/html && find . -type f -print0 | xargs -0 sed -i 's/https:\/\/www\.youtube\.com//g'
endif
	#Delete all pyc files
	find $(tmpInstall) -name '*.pyc' -print0 | xargs -0 rm -f
	find $(tmpInstall) -name '__pycache__' -print0 | xargs -0 rm -rf
	find $(tmpInstall) -name 'yade.py' -print0 | xargs -0 rm -f

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

override_dh_installman:
	dh_installman -p yade yade.1 yade-batch.1

override_dh_compress:
	dh_compress --all -X.py -X.stl -X.gts -X.geo -X.mesh -X.msh -X.pdf -X.png -X.svg -X.txt -X.js -X.inv

override_dh_auto_test:

override_dh_installdocs:
	dh_installdocs
ifeq ($(BUILD_DOC), yes)
	dh_sphinxdoc
endif

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(BUILDDIR)

override_dh_dwz:

=== debian/watch ===
version=4
opts=uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|b|a)\d*)$/$1~$2/,dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$// https://github.com/yade/trunk/tags .*/(\d.*)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))
